--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer

local missileSpeed = 72*FRACUNIT
local missileSpread = 60*ANG1
local missileAmt = 8

freeslot(
	"MT_ELEMBUKIFIRE_MISSILE",
	
	"S_ELEMBUKIFIRE_MISSILE",
	"S_ELEMBUKIFIRE_PARTICLE",
	"S_ELEMBUKIFIRE_EXPLODE",
	
	"SPR_ELMF",
	
	"sfx_elmfht",
	"sfx_elmflp"
)

mobjinfo[MT_ELEMBUKIFIRE_MISSILE] = {
	doomednum = -1,
    spawnstate = S_ELEMBUKIFIRE_MISSILE,
	deathstate = S_ELEMBUKIFIRE_EXPLODE,
	deathsound = sfx_elmfht,
    spawnhealth = 9000,
    radius = 72*FRACUNIT,
    height = 16*FRACUNIT,
	speed = missileSpeed,
    flags = MF_MISSILE
}

states[S_ELEMBUKIFIRE_MISSILE] = {
        sprite = SPR_ELMF,
        frame = FF_FULLBRIGHT|A,
        tics = 4,
		nextstate = S_ELEMBUKIFIRE_MISSILE,
}

states[S_ELEMBUKIFIRE_PARTICLE] = {
        sprite = SPR_ELMF,
        frame = FF_FULLBRIGHT|B,
        tics = 6,
		nextstate = S_NULL,
}

states[S_ELEMBUKIFIRE_EXPLODE] = {
        sprite = SPR_ELMF,
        frame = FF_ANIMATE|FF_FULLBRIGHT|C,
        tics = 6*3,
		nextstate = S_NULL,
		var1 = 6,
		var2 = 3
}

local function K_FlipFromObject(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP)
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP)

	if (mo.eflags & MFE_VERTICALFLIP) then
		mo.z = $ + (master.height - FixedMul(master.scale, mo.height))
	end
end

local function spawnFireMissile(source, angle, speed, iter)
	local missile
	local x, y, z
	
	local finalspeed = missileSpeed
	if (gamespeed == 0) then
		finalspeed = FixedMul(finalspeed, FRACUNIT-FRACUNIT/4)
	elseif (gamespeed == 2)
		finalspeed = FixedMul(finalspeed, FRACUNIT+FRACUNIT/4)
	end
	finalspeed = FixedMul(finalspeed, mapobjectscale)

	
	x = source.x + source.momx + FixedMul(finalspeed, cos(angle))
	y = source.y + source.momy + FixedMul(finalspeed, sin(angle))
	z = source.z + source.height + FRACUNIT
	
	missile = P_SpawnMobj(x, y, z, MT_ELEMBUKIFIRE_MISSILE)
	missile.target = source
	if (source.eflags & MFE_VERTICALFLIP) then
			missile.z = $ - source.height
			missile.flags2 = $|MF2_OBJECTFLIP
			missile.eflags = $|MFE_VERTICALFLIP
	end
	missile.threshold = 10
	missile.movefactor = finalspeed/2
	
	if missile then
		missile.angle = angle
		missile.momx = FixedMul(finalspeed/4, cos(angle))
		missile.momy = FixedMul(finalspeed/4, sin(angle))
		missile.momz = (12*mapobjectscale + min(2*abs(abs(iter - 4) - 4)*mapobjectscale, 5*mapobjectscale) + source.momz)*P_MobjFlip(source)
		
		if (missile.eflags & MFE_UNDERWATER) then
			missile.momz = (117 * missile.momz) / 200
		end
		
		missile.cvmem = source.player and source.player.skincolor or SKINCOLOR_ORANGE
		S_StartSoundAtVolume(missile, sfx_elmflp, 64)
	end
end

local function spawnFireMissileParticle(mo)
	local ghost = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	ghost.state = S_ELEMBUKIFIRE_PARTICLE
	ghost.angle = mo.angle
	ghost.momx = 5 * (mo.momx / 7) 
	ghost.momy = 5 * (mo.momy / 7)
	ghost.momz = (mo.momz / 3)
	
	ghost.scale = mo.scale*2
	ghost.destscale = 0
	ghost.scalespeed = mo.scale*2/7
end

local function spawnPlayerFireMissileParticle(mo)
	local ghost = P_SpawnMobj(mo.x, mo.y, mo.z+2*mo.height/3, MT_THOK)
	ghost.state = S_ELEMBUKIFIRE_PARTICLE
	ghost.angle = mo.angle
	ghost.momx = 5 * (mo.momx / 7) 
	ghost.momy = 5 * (mo.momy / 7)
	ghost.momz = (mo.momz / 3)
	
	ghost.scale = mo.scale
	ghost.destscale = 0
	ghost.scalespeed = mo.scale/7
end

local function fireBukiOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	if p.mo.skin == "elementa" then 
		return newodds
	else
		return 0
	end
end

local function fireBukiShow(p)
	return p.mo.skin == "elementa"
end

local function fireBukiDropped(mo, i, amt)
	mo.threshold = KITEM_ORBINAUT
	return SPR_ITEM, 6
end

local function fireBukiUse(p, cmd)
	local mo = p.mo
	
	p.kartstuff[k_itemamount] = $-1
	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE/2)
	K_PlayBoostTaunt(mo)
	
	p.elemFireBukiUseTimer = TICRATE/2
	
	for i = 1, (missileAmt-1) do
		spawnFireMissile(mo, mo.angle - (missileSpread/2) + (missileSpread/missileAmt*i), FixedMul(missileSpeed, mapobjectscale), i)
	end
	spawnFireMissile(mo, mo.angle, FixedMul(missileSpeed, mapobjectscale), missileAmt)
end

addHook("MobjThinker", function(mo)
	if mo.state == S_ELEMBUKIFIRE_MISSILE then
		A_JawzChase(mo)
		spawnFireMissileParticle(mo)
	else
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
	end
end, MT_ELEMBUKIFIRE_MISSILE)

local function canUseItem(p)
	return (p and p.mo and p.mo.health > 0 and (not p.spectator) and (not p.exiting)
		and p.kartstuff[k_spinouttimer] == 0 and p.kartstuff[k_squishedtimer] == 0 and p.kartstuff[k_respawn] == 0
		and leveltime > 0)
end

addHook("ThinkFrame", do
	for p in players.iterate do
		local mo = p.mo
		if mo and mo.valid then
-- 	 		if p.kartstuff[k_itemtype] == xItemLib.xItemNamespaces["XITEM_ELEMBUKI_FIRE"] then
-- 	 			spawnPlayerFireMissileParticle(mo)
-- 	 		end
			if p.elemFireBukiUseTimer then
				p.elemFireBukiUseTimer = $-1
-- 				spawnPlayerFireMissileParticle(mo)
				if canUseItem(p) then
					if mo.skin == "elementa" then
						mo.frame = FF_FULLBRIGHT|T
					else
						mo.frame = FF_FULLBRIGHT|$
					end
					if (p.elemFireBukiUseTimer % 2) == 0 then
						mo.color = SKINCOLOR_FLAME
					else
						mo.color = p.skincolor
					end
				else
					p.elemFireBukiUseTimer = 1
					mo.color = p.skincolor
				end
				if p.elemFireBukiUseTimer == 0 then
					mo.color = p.skincolor
-- 	 				K_PlayAttackTaunt(mo)
				end
			end
		end
	end
end)

addHook("PlayerSpin", function(p, inflictor, source)
	if inflictor and inflictor.type == MT_ELEMBUKIFIRE_MISSILE then
		if fesScoring and source.player then
			FES_scoring_rewardPlayerAction(inflictor.player, "elemfire")
		end
	end
end)

if xItemLib then
	xItemLib.func.addItem{"XITEM_ELEMBUKI_FIRE", 
		"Flame Fury", 
		"K_ITFIRE", 
		"K_ISFIRE", 
		XIF_COOLDOWNONSTART,
		{0, 0, 1, 4, 3, 2, 0, 0, 0, 0}, 
		{3, 0}, 
		nil, 
		fireBukiUse, 
		false, 
		fireBukiOdds, 
		false, 
		{0, {SPR_ELMF, 8}}, 
		fireBukiShow, 
		nil, 
		fireBukiDropped
	}
end

if fesScoring then
	FES_scoring_addAction("elemfire", "Flame Fury Accuracy", 25)
end